dnl $Id$
dnl
dnl     Tracerx autoconf macros
dnl     Copyright (c) 1998, 1999 Mike D. Schiffman <mike@infonexus.com>
dnl     All rights reserved.
dnl

dnl
dnl Looks for a previous libnet version and attempts to determine which verion
dnl it is.  Version 0.8 was the first version that actually knew internally
dnl what version it was.
dnl
dnl usage:
dnl
dnl     AC_LIBNET_CHECK_LIBNET_VERSION
dnl
dnl results:
dnl
dnl
dnl

AC_DEFUN(AC_TRACERX_CHECK_LIBNET_VER,
[
    AC_CHECK_LIB(net, build_ip, AC_MSG_CHECKING(version) \

    if ! test -f $LIB_PREFIX/libnet.a; then
        AC_MSG_RESULT($LIB_PREFIX/libnet.a doesn't exist)
        AC_MSG_ERROR(can't find libnet)
    else
        __LIBNET_VERSION=`strings $LIB_PREFIX/libnet.a | grep "libnet version"\
                | cut -f3 -d" "`;\
        if test -z "$__LIBNET_VERSION"; then
            AC_MSG_ERROR(Libnet version <0.8.  You are way behind the times.\ 
  Please get version 0.99c or better from http://www.packetfactory.net/libnet.)

        elif $__LIBNET_VERSION -lt 0.99c; then
            AC_MSG_ERROR($__LIBNET_VERSION is too old.  GET NEW ONE.)
        else
            AC_MSG_RESULT(Libnet version $__LIBNET_VERSION ok.)
        fi
    fi\
    )
])


dnl EOF
