/*
 * THE NEMESIS PROJECT
 * Copyright (C) 1999, 2000, 2001 Mark Grimes <obecian@packetninja.net>
 * Portions copyright (C) 2001 Jeff Nathan <jeff@wwti.com>
 *
 * nemesis-dns.h (DNS Packet Injector)
 *
 */


#define TITLE "DNS Packet Injection -=- The NEMESIS Project"
#define VERSION "1.32"
#define CODERS "Copyright (C) 1999, 2000, 2001 Mark Grimes <obecian@packetninja.net>"
#define NEWCODERS "Portions copyright (C) 2001 Jeff Nathan <jeff@wwti.com>"

#include <stdio.h>
#include <strings.h>
#include <stdlib.h>
#include <unistd.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <libnet.h>
#include <pcap.h>

#define PROMISC 1
#define SNAPLEN 128
#define TIMEOUT 1024
#define OPTIMIZE 0
#define PADDING 15

u_short         id,		/* IP id */
                urgp,		/* TCP urgent data pointer */
                frag,		/* frag shit */
                sport,		/* source port */
                dport,		/* destination port */
                fl_opt,		/* TCP flag options */
                win,		/* window size */
                did,		/* DNS id */
                dflags,		/* DNS flags */
                num_q,		/* DNS */
                num_anws_rr,	/* DNS resource records */
                num_auth_rr,	/* DNS resource records */
                num_addi_rr;	/* DNS resource records */
u_long          source,		/* source address */
                dest,		/* destination address */
                seq,		/* sequence number */
                ack;		/* acknowledgement number */
u_int           enet_tmp[6];
u_char          enet_src[6],	/* source MAC address */
                enet_dst[6],	/* destination MAC address */
                ttl,		/* time to live */
                tos,		/* type of service */
                flags,		/* enum flags */
               *payload,	/* payload pointer */
                options[40];	/* IP options pointer */

int             got_link, got_options, got_payload;	/* sanity check */

int             option_s;	/* IP option size */
int             payload_s;	/* payload size */

char           *device;		/* network device */

char            errbuf[256];
struct ether_addr *e;
struct libnet_link_int *l2;

int             verbose;	/* verbosity */
int             state;		/* 0 = UDP, 1 = TCP */

int             builddns();

void            hexdump(char *, int);
void            usage(char *);
void            defaults();	/* defaults for packet fields */

int             nbytes;

#ifndef IPOPT_SECURITY
#define IPOPT_SECURITY	130
#endif

/* flag bits */
#define SYN (1     )
#define ACK (1 << 1)
#define RST (1 << 2)
#define PSH (1 << 3)
#define URG (1 << 4)
#define FIN (1 << 5)
