/*
 * THE NEMESIS PROJECT
 * Copyright (C) 1999, 2000, 2001 Mark Grimes <obecian@packetninja.net>
 * Portions copyright 2001 Jeff Nathan <jeff@wwti.com>
 * 
 * nemesis-icmp.h (ICMP Packet Injector)
 * 
 */


#define TITLE "ICMP Packet Injection -=- The NEMESIS Project"
#define VERSION "1.32"
#define CODERS "Copyright (C) 1999, 2000, 2001 Mark Grimes <obecian@packetninja.net>"
#define NEWCODERS "Portions copyright (C) 2001 Jeff Nathan <jeff@wwti.com>"

#include <stdio.h>
#include <strings.h>
#include <stdlib.h>
#include <unistd.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <libnet.h>
#include <pcap.h>

#define PROMISC 1
#define SNAPLEN 128
#define TIMEOUT 1024
#define OPTIMIZE 0
#define PADDING 15

n_time          otime,		/* originating time */
                rtime,		/* received time */
                ttime;		/* xmitted time */
u_short         id,		/* IP id */
                frag;		/* frag shit */
u_long          source,		/* source address */
                dest,		/* destination address */
                seq,		/* sequence number */
                mask,		/* subnet mask (icmp_mask) */
                gwy;		/* preferred gateway (icmp_redirect) */
u_int           enet_tmp[6];
u_char          enet_src[6],	/* source MAC address */
                enet_dst[6],	/* destination MAC address */
                ttl,		/* time to live */
                tos,		/* type of service */
                proto,		/* protocol type */
                type,		/* ICMP packet type */
                code,		/* ICMP packet code */
               *payload,	/* payload pointer */
                options[40];	/* IP options pointer */

int             got_link, got_options, got_payload;	/* sanity checks */
int             option_s;	/* IP option size */
int             payload_s;	/* payload size */

char           *device;		/* network device */

int             verbose;	/* verbosity */

char            errbuf[256];
struct ether_addr *e;
struct libnet_link_int *l2;

int             buildicmp();

void            hexdump(char *, int);
void            usage(char *);
void            defaults();	/* defaults for packet fields */

int             nbytes;

#ifndef IPOPT_SECURITY
#define IPOPT_SECURITY	130
#endif
