/*
 * THE NEMESIS PROJECT
 * Copyright (C) 1999, 2000, 2001 Mark Grimes <obecian@packetninja.net>
 * Portions copyright (C) 2001 Jeff Nathan <jeff@wwti.com>
 *
 * nemesis-rip.h (RIP Packet Injector)
 *
 */


#define TITLE "RIP Packet Injection -=- The NEMESIS Project"
#define VERSION "1.32"
#define CODERS "Copyright (C) 1999, 2000, 2001 Mark Grimes <obecian@packetninja.net>"
#define NEWCODERS "Portions copyright (C) 2001 Jeff Nathan <jeff@wwti.com>"

#include <stdio.h>
#include <strings.h>
#include <stdlib.h>
#include <unistd.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <libnet.h>
#include <pcap.h>

#define PROMISC 1
#define SNAPLEN 128
#define TIMEOUT 1024
#define OPTIMIZE 0
#define PADDING 15

u_short         rd,		/* RIP route domain - zero for RIP format */
                rt,		/* RIP route tag - zero for RIP format */
                af,		/* RIP address family */
                id,		/* IP id */
                frag,		/* frag shit */
                sport,		/* source port */
                dport;		/* destination port */
u_long          addr,		/* RIP IP address */
                mask,		/* RIP network mask */
                next_hop,	/* RIP next hop */
                metric,		/* RIP metric (16 = no route) */
                source,		/* source address */
                dest;		/* destination address */
u_int           enet_tmp[6];
u_char          enet_src[6],	/* source MAC address */
                enet_dst[6],	/* destination MAC address */
                cmd,		/* RIP command 1REQ 2RPLY */
                ver,		/* RIP version */
                ttl,		/* time to live */
                tos,		/* type of service */
               *payload,	/* payload pointer */
                options[40];	/* IP options pointer */

int             got_link, got_options, got_payload;	/* sanity check */

int             option_s;	/* IP option size */
int             payload_s;	/* payload size */

char            errbuf[256];
struct ether_addr *e;
struct libnet_link_int *l2;

char           *device;		/* network device */

int             verbose;	/* verbosity */

int             buildrip();

void            hexdump(char *, int);
void            usage(char *);
void            defaults();	/* defaults for packet fields */

int             nbytes;

#ifndef IPOPT_SECURITY
#define IPOPT_SECURITY	130
#endif
