/*****************************************************************
  Filename    : sample.cpp
  Description : check xxxxxx vulnerable
  Author      : glacier
  Update      : 2001-11-09

  Copyright (C) 2001 http://www.xfocus.org   All Rights Reserved
 *****************************************************************/

//---------------------------------------------------------------------------
#include <stdio.h>
#include <winsock.h>
#include <string.h>

#pragma comment(lib, "ws2_32.lib")

#define MAXLEN 256
#define PLUGIN_PARAMS_1 1

typedef VOID (CALLBACK *PALERT_USER) (
    char *szHostName,
    char *szVulnName,
    char *szLine);

typedef VOID (CALLBACK *PLOG_TO_FILE) (
    char *szLogFileName,
    char *szLine);

/* plug-in basic information */
typedef struct _PLUGIN_INFO {
    char            szClassName[50];        /* type of plug-in */
    char            szMemberName[50];       /* name of plug-in components */
    char            szVersion[10];          /* plug-in version */
    char            szFileName[50];         /* original file name of plug-in */
    char            szParamsRequest[50];    /* choose the parameters,such as"-cgi" */
    char            szPrompt[200];          /* explanation of parameter, such as "-cgi: check HTTP vulnerability" */
    int             nSingle;                /* If it's the only vulnerability(the number of vulnerability can be 1 or 0, such as Netbios information) */
    char            szAuthorName[50];       /* Author of the plug-ins */
    char            szRisk[10];             /* vulnerability risk ranking */
    char            szDescription[300];     /* vulnerability description in plug-ins */
    char            szAdvice[300];          /* suggestion about vulnerability in plug-ins */
    int             nTimeOut;               /* time-out limitation, "0" stands for no limitation */
    int             nParamsType;            /* function type(PLUGIN_PARAMS_1)of plug-in export function "PluginFunc()" */
    int             nMark;                  /* identify whether this plug-in has been marked by  a modular */
} PLUGIN_INFO;

/* plug-in running parameters */
typedef struct _SCAN_PARAMS_1 {
    char            szHostName[MAXLEN];     /* host address */
    char            szParams[MAXLEN];       /* user input parameters */
    int             nMaxThread;             /* max thread number */
    int             *pnThreadCount;         /* current thread number */
    char            *szCurrentSchedule;     /* current task */
    int             nVerbose;               /* if display the detail information */
    char            szLogFileName[MAXLEN];  /* log file name(including the path) */
    PALERT_USER     pAlertUser;             /* call-back function "AlertUser()" address */
    PLOG_TO_FILE    pLogToFile;             /* call-back function "LogToFile()" address */
    char            szResultBuf[MAXLEN];    /* dynamical returned information */
    int             nVulnCount;             /* number of vulnerabilities */
}SCAN_PARAMS_1;

extern "C" __declspec(dllexport) BOOL GetPluginInfo(PLUGIN_INFO*);
extern "C" __declspec(dllexport) BOOL PluginFunc(SCAN_PARAMS_1*);

static PALERT_USER     pAlertUser = NULL;
static PLOG_TO_FILE    pLogToFile = NULL;


int CheckVuln(char *szHostName)
{
    int nRtn = 0;

    // ...

    return nRtn;
}

/*
 -	GetPluginInfo()
 -
 *	Function:
 *              The function is quoted when initializing plug-ins,
 *              initializing plug-ins,
 *              which is used to acquire the plug-in basic information.
 *
 *	Parameter:
 *              OUT pstPluginInfo   -  plug-in basic information
 *              IN
 *
 *	Result:
 *              TRUE                -  plug-in initialized successfully
 *              FALSE               -  plug-in initialization failed
 */
__declspec(dllexport) BOOL GetPluginInfo(PLUGIN_INFO *pstPluginInfo)
{
    strcpy(pstPluginInfo->szClassName, "SAMPLE");
    strcpy(pstPluginInfo->szMemberName, "sample");
    strcpy(pstPluginInfo->szVersion, "1.0");
    strcpy(pstPluginInfo->szFileName, "sample.dll");
    strcpy(pstPluginInfo->szParamsRequest, "-sample");
    strcpy(pstPluginInfo->szPrompt, "-sample: check xxxxxx");
    pstPluginInfo->nSingle = 0;
    strcpy(pstPluginInfo->szAuthorName, "glacier");
    strcpy(pstPluginInfo->szRisk, "high");
    strcpy(pstPluginInfo->szDescription, "");
    strcpy(pstPluginInfo->szAdvice, "");
    pstPluginInfo->nTimeOut = 0;
    pstPluginInfo->nParamsType = PLUGIN_PARAMS_1;
    pstPluginInfo->nMark = 1;

    return TRUE;
}


/*
 -	PluginFunc()
 -
 *	Function:
 *              This function is quoted when scanning host.
 *              Input the host information and return the scanning result.
 *
 *	Parameter:
 *              OUT IN pstScanParams    -  plug-in running parameters
 *
 *	Result:
 *              TRUE                    -  there are some vulnerabilities
 *              FALSE                   -  there's no vulnerabilities
 */
__declspec(dllexport) BOOL PluginFunc(SCAN_PARAMS_1 *pstScanParams_1)
{
    char    szHostName[MAXLEN];
    char    szLogFileName[MAXLEN];
    int     nVerbose = 0;
    int     nVulnCount = 0;
    int     nMaxThread = 0;
    int     *pnThreadCount = NULL;

    BOOL    bResult = FALSE;

    strcpy(szHostName, pstScanParams_1->szHostName);
    strcpy(szLogFileName, pstScanParams_1->szLogFileName);
    nVerbose = pstScanParams_1->nVerbose;
    nMaxThread = pstScanParams_1->nMaxThread;
    pnThreadCount = pstScanParams_1->pnThreadCount;
    pAlertUser = pstScanParams_1->pAlertUser;
    pLogToFile = pstScanParams_1->pLogToFile;
    pstScanParams_1->nVulnCount = 0;

    while ((*pnThreadCount) >= nMaxThread) {
        Sleep(100);
    }

    (*pnThreadCount)++;

    if (nVerbose) {
        pAlertUser(szHostName, NULL, "Checking xxxxxx ...");
    }

    __try {
        nVulnCount = CheckVuln(szHostName);
    }
    __except (EXCEPTION_EXECUTE_HANDLER) {
        __try {
            pAlertUser(NULL, NULL, "Function \"CheckVuln()\" causes an exception.");
        }
        __except (EXCEPTION_EXECUTE_HANDLER) {
            printf("%s\n", "Function \"CheckVuln()\" causes an exception, failed to alert user.");
        }
    }

    (*pnThreadCount)--;

    pstScanParams_1->nVulnCount = nVulnCount;
    if (nVulnCount > 0) {
        bResult = TRUE;
        pAlertUser(szHostName, "vuln_name", "xxxxxx");
        pLogToFile(szLogFileName, "Found xxxxxx");
    }

    pAlertUser(szHostName, NULL, "xxxxxx scan complete.");

    return bResult;
}


/*
 -	DllEntryPoint()
 -
 *	Function:
 *              dll main function
 *
 *	Parameter:
 *              OUT
 *              IN
 *
 *	Result:
 *
 */
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
    return 1;
}
//---------------------------------------------------------------------------
