# os definitions in sscan scripting language!
#
# the response[] command checks responses to queSO obscure packets
# against specified flags and tcp hdr fieldz:
# S = syn, A = ack, F = fin, R = rst, P = push,
# N = acknum > 1, W = window > 1.
# window[] checks if the specified window size is equal to the window
# size in the packet.. *NOT IMPLEMENTED YET*
# so response[4,SFA] checks if the response to packet number 4
# had flags syn fin and ack enabled (if other flags were also enabled
# response[] returns false too..
# YOU CAN USE CRITERIA BESIDES OBSCURE PACKETS FOR OS DETECTION:
# you can any of the standard script commands, sh[], port[], rpc[],
# start*dialog[], etc.

response[1,WR]
response[2,nothing!]
response[3,WR]
response[4,NWSA]
response[5,nothing!]
telnetbanner[FreeBSD]
registeros[freebsd, unidentified version]

response[1,WR]
response[2,nothing!]
response[3,WR]
response[4,NWSA]
response[5,nothing!]
telnetbanner[OpenBSD]
registeros[openbsd, unidentified version]

response[1,WR]
response[2,nothing!]
response[3,WR]
response[4,NWSA]
response[5,nothing!]
registeros[freebsd, netbsd, or openbsd]

response[1,RN]
response[2,RAN]
response[3,RN]
response[4,SAWN]
response[5,RAN]
registeros[windows 95/98/nt]

response[1,R]
response[2,RAN]
response[3,R]
response[4,SANW]
response[5,RAN]
registeros[cisco ios 11.x]

response[1,nothing!]
response[2,NRA]
response[3,R]
response[4,nothing!]
response[5,NRA]
registeros[cisco ios 11.x]

telnetbanner[User Access]
registeros[cisco ios 11.x]

# solaris detection is very hard.. we resort to other methods
# at the bottom of this file if we couldnt get the telnet banner
telnetbanner[Solaris]
telnetbanner[2.6]
registeros[solaris 2.6]

telnetbanner[Solaris]
registeros[solaris 2.x]

telnetbanner[SunOS]
registeros[solaris 2.x]

port[1]
registeros[irix unknown version]

telnetbanner[UNIX]
registeros[solaris 2.x]

telnetbanner[BSD]
registeros[*bsd* unknown version ;)]

telnetbanner[BSDI]
registeros[bsdi unknown version]

telnetbanner[IRIX]
registeros[irix 6.x]

response[4,SFAWN]
telnetbanner[Red Hat]
telnetbanner[5.2]
registeros[redhat linux 5.2]

response[4,SFAWN]
telnetbanner[Red Hat]
telnetbanner[5.1]
registeros[redhat linux 5.1]

response[4,SFAWN]
telnetbanner[Red Hat]
telnetbanner[5.0]
registeros[redhat linux 5.0]

response[4,SFAWN]
telnetbanner[Red Hat]
telnetbanner[4]
registeros[redhat linux 4.x]

telnetbanner[Red Hat]
registeros[redhat linux unknown version]

response[4,SFAWN]
response[2,nothing!]
response[5,nothing!]
registeros[linux 2.0.x]

response[1,R]
response[2,nothing!]
response[3,R]
response[4,NWSFA]
response[5,nothing!]
registeros[linux 1.2.x]

response[4,NWSFA]
registeros[linux 2.0.x]

telnetbanner[Linux]
registeros[linux 2.0.x]

response[1,R]
response[2,nothing!]
response[3,nothing!]
response[4,NWSA]
response[5,nothing!]
registeros[novell netware]

response[1,R]
response[2,NRA]
response[3,R]
response[4,NWA]
response[5,NRA]
registeros[irix 6.x or bsdi]

response[1,R]
response[2,RA] 
response[3,R]
response[4,RA]
registeros[cisco igs (router)]

telnetbanner[IRIX]
registeros[irix unknown version]

telnetbanner[telnet]
registeros[aix unknown version]

response[1,R]
response[2,nothing!]
registeros[solaris 2.x]

response[1,R]
response[2,nothing!]
response[3,R]
response[4,NWSA]
response[5,nothing!]
registeros[linux 2.1, possibly netbsd]

response[1,R]
response[2,nothing!]
response[3,R]
response[4,NWSA]
response[5,nothing!]
registeros[macintosh os version 8]

response[1,WR]
response[3,WR]
response[4,NA]
registeros[macintosh tcp (MacTCP)]

response[1,NRA]
response[2,nothing!]
response[3,NRA]
response[4,NRA]
registeros[hp jetdirect printer]

response[1,NRA]
response[2,nothing!]
response[3,NRA]
response[4,WNRA]
registeros[hp jetdirect printer]

response[1,NRA]
response[2,nothing!]
response[3,NRA]
response[4,WNSA]
registeros[hp jetdirect printer]

response[1,WR]
response[2,nothing!]
response[3,WR]
response[4,NWA]
response[5,nothing!]
registeros[vax/vms, openvms]

response[1,WR]
response[2,NRA]
response[3,R]
response[4,NWA]
response[5,NRA]
registeros[hp-ux b.10.20]

response[1,NRAP]
response[2,NRAP]
response[3,NRAP]
response[4,NWSA]
response[5,NRAP]
registeros[3com office connect switch (router)]

response[1,RAN]
response[2,RAN]
response[3,RAN]
response[4,SANW]
registeros[3com netbuilder (router)]

response[1,nothing!]
response[2,nothing!]
response[3,nothing!]
response[4,NWSA]
response[5,nothing!]
registeros[clamIP nautica router by bay networks]

response[1,WR]
response[2,nothing!]
response[3,WR]
response[4,NWRA]
response[5,nothing!]
registeros[digital vms or ultrix]

response[1,NWSA]
response[2,nothing!]
response[3,nothing!]
response[4,NWSA]

response[1,NWR]
response[2,nothing!]
response[3,nothing!]
response[4,NWRA]
registeros[minix, unknown version]

response[1,nothing!]
response[2,nothing!]
response[3,nothing!]
response[4,NRA]
registeros[livingston portmaster comOS 3.5]

response[1,UR]
response[2,NURA]
response[3,UR]
response[4,NWSA]
response[5,NURA]
registeros[usr/3com netserver]

response[1,NRA]
response[2,NRA]
response[3,NRA]
response[4,NRA]
response[5,NRA]
registeros[livingston portmaster]

response[1,NR]
response[2,NRA]
response[3,NR]
response[4,nothing!]
response[5,NRA]
registeros[ibm as/400]

response[1,R]
response[2,NRA]
response[3,R]
response[4,nothing!]
response[5,NRA]
registeros[hp-ux b.11.00]

response[2,NRA]
response[3,NRA]
response[4,NWSA]
response[5,NRA]
registeros[shiva isdn router]

response[1,WR]
response[2,nothing!]
response[3,nothing!]
response[4,nothing!]
response[5,nothing!]
registeros[aix 4.x]

response[1,R]
response[2,nothing!]
response[3,nothing!]
response[4,nothing!]
response[5,nothing!]
registeros[aix 4.x]

port[139]
registeros[windows 95/98/nt]
